package com.css.simulation.resource.algorithm.service;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.param.algorithm.AlgorithmParameter;

import java.io.IOException;
import java.security.KeyManagementException;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.util.Map;


public interface AlgorithmService {

    ResponseBodyVO addOrUpdate(AlgorithmParameter param) throws IOException;

    ResponseBodyVO selectAlgorithmList(AlgorithmParameter param);

    ResponseBodyVO selectAlgoPlatformList(AlgorithmParameter param);

    ResponseBodyVO deleteByid(AlgorithmParameter param);

    ResponseBodyVO selectDetailsById(AlgorithmParameter param);

    ResponseBodyVO isAlgorithmRunning(AlgorithmParameter param);

    ResponseBodyVO selectSharedAlgorithmList(AlgorithmParameter param);

    ResponseBodyVO shareAlgorithm(AlgorithmParameter param);

    ResponseBodyVO testConnection(AlgorithmParameter param);

    ResponseBodyVO getGitVersion(AlgorithmParameter param) throws NoSuchAlgorithmException, KeyStoreException, KeyManagementException, IOException;

    Map<String,Integer> selectDetailsBySy();
}
